﻿
Module Module1

    'Define the interface
    Interface IClient

        Sub Order(ByVal orderNum As Integer)
        Property Name() As String
        Property Address() As String

    End Interface

    'Create a Customer class that implements the IClient interface
    Public Class Customer

        Implements IClient

        'Implement the properties
        Public Property Name As String Implements IClient.Name
	Public Property Address As String Implements IClient.Address

        Public Sub New(ByVal s As String)

            Console.WriteLine("Creating a New Customer ID: {0}", s)

        End Sub

        'Implement the Order method
        Public Sub Order(ByVal newOrder As Integer) Implements IClient.Order

            Console.WriteLine("Implementing the Order Method for IClient. The Order Number is: {0}", newOrder)

        End Sub

    End Class


    Class Tester

        Public Sub Run()

            Dim cust As Customer = New Customer("H56388")
            cust.Name = "Brian Ferry"
            cust.Address = "23 Orange Lane, Clifton, Bristol, BS6 5FH"
            Console.WriteLine("The Name of the Customer is: {0}", cust.Name)
            Console.WriteLine("The Address of the Customer is: {0}", cust.Address)
            cust.Order(1234)

        End Sub

    End Class


    Sub Main()

        Dim t As Tester = New Tester()
        t.Run()
        Console.ReadLine()

    End Sub

End Module

